#ifndef lint
static char rcsid[] = "$Header: alloc.c,v 1.1 86/10/04 03:32:35 chris Exp $";
#endif

char	*malloc(), *strcpy();

#define OVERHEAD_GUESS 16	/* a guess at malloc()'s overhead */

/*
 * Return a good guess as to how many objects of size `size' exactly
 * fill a malloc() block (but always return at least 2).
 */
int
ntoalloc(size)
	unsigned size;
{
	register int n;
	static int pagesize;

	if (pagesize == 0)
		pagesize = getpagesize() - OVERHEAD_GUESS;
	n = pagesize / size;
	if (n < 2)
		n = 2;
	return (n);
}

/*
 * Allocate a string.  It can never be free'd.
 */
char *
poolstr(s)
	char *s;
{
	register int len;
	static char *pool;
	static int poolsize, pagesize;

	if (s == 0)
		return (0);
	len = strlen(s) + 1;
	if (poolsize < len) {
		if (pagesize == 0)
			pagesize = getpagesize() - OVERHEAD_GUESS;
		poolsize = len > pagesize ? len : pagesize;
		pool = malloc((unsigned) poolsize);
		if (pool == 0)
			err(1, "poolstr: out of memory: %m");
	}
	poolsize -= len;
	(void) strcpy(pool, s);
	pool += len;
	return (pool - len);
}

/*
 * Non-pool version of the above, so that strings may be returned.
 */
char *
savestr(s)
	char *s;
{
	register char *cp;

	if (s == 0)
		return (0);
	cp = malloc((unsigned) (strlen(s) + 1));
	if (cp == 0)
		err(1, "savestr: out of memory: %m");
	(void) strcpy(cp, s);
	return (cp);
}
