#ifndef lint
static char rcsid[] = "$Header: err.c,v 1.2 87/06/13 00:25:05 pete Exp $";
#endif

#include <stdio.h>
#ifdef pyr
#include <varargs.h>
#endif

/*
 * Gripe, and optionally exit.
 * `%m' in the format string is replaced with the system error message
 * associated with `errno'.
 */
#ifdef lint
/* VARARGS2 */
err(quit, ffmt)
	int quit;
	char *ffmt;
#else lint
#if defined(vax) || defined(sun)
err(quit, ffmt, arg)
	int quit;
	char *ffmt;
#else vax || sun
err(va_alist)
	va_dcl
#endif vax || sun
#endif lint
{
	register char *fmt;
	register char *p, *s = NULL;
	register int n, c, newline = 0;
	char newfmt[1024];
	char unknown[40];
	extern int errno;
	extern char *sys_errlist[];
	extern int sys_nerr;

#if defined(vax) || defined(sun)
	fmt = ffmt;
#else
	int quit;
	va_list l;

	va_start(l);
	quit = va_arg(l, int);
	fmt = va_arg(l, char *);
#endif
	p = newfmt;
	n = sizeof (newfmt);
	for (;;) {
		if (s != NULL) {
			if ((c = *s++) == 0) {
				s = NULL;
				continue;
			}
		} else {
			if ((c = *fmt++) == 0)
				break;
			if (c == '%' && *fmt == 'm') {
				fmt++;
				if (errno < 0 || errno > sys_nerr) {
					(void) sprintf(unknown,
						"unknown error code %d",
						errno);
					s = unknown;
				} else
					s = sys_errlist[errno];
				continue;
			}
		}
		if (--n <= 0)	/* out of format space */
			break;	/* should complain, but where? */
		*p++ = c;
		/*
		 * Determine whether we will put a new line character
		 * at the end of the output string.  If not, we append
		 * one afterward.
		 *
		 * Okay, so this is only approximate.  So what?
		 */
		newline = c == '\n';
	}
	*p = 0;

#ifdef lint
	(void) fputs(newfmt, stderr);
#else
#if defined(vax) || defined(sun)
	_doprnt(newfmt, &arg, stderr);	/* magic */
#else
	_doprnt(newfmt, l, stderr);
#endif
#endif
	if (!newline)
		(void) putc('\n', stderr);

	if (quit)
		exit(quit);
#if !defined(vax) && !defined(sun)
	va_end(l);
#endif
}
