
/*
 */
#include <stdio.h>
#include <sys/types.h>
#include <lastlog.h>
#include <sys/stat.h>
#include <sys/file.h>
#include "mf.h"

struct	mapfent *mf;		/* the map */
int	nmf;			/* and its size */
int	mtmp;		

#define LASTLOG		"/usr/adm/lastlog"
#define	MAPUID(uid) ((uid) >= nmf ? -1 : mf[uid].mf_uid)
#define	MAPGID(gid) ((gid) >= nmf ? -1 : mf[gid].mf_gid)

main(argc, argv)
	register int argc;
	register char **argv;
{

	setup();
	readmap();
	cleanup();
}

int	lfd, nfd;
char	outf[100];

setup()
{
	struct  lastlog lastlog;
	if ((lfd = open(LASTLOG, O_RDONLY)) < 0 )
		err(1, "cannot open lastlog file %s", LASTLOG);
	strcpy(outf, LASTLOG);
	strcat(outf, ".new");
	if ((nfd = open(outf, O_CREAT|O_WRONLY, 0666)) < 0 )
		err(1, "cannot open new lastlog file %s", outf);
}

readmap()
{
	register struct mapfent *m;
	int fd;
	unsigned short magic;
	struct stat st, lst;
	char fn[100];
	struct  lastlog lastlog;

	(void) strcpy(fn, "/map");
	fd = open(fn, 0);
	if (fd < 0) {
		fn[0] = '/';
		(void) gethostname(fn + 1, sizeof fn - 6);
		(void) strcat(fn, ".map");
		fd = open(fn, 0);
		if (fd < 0) {
			printf ("error in open\n");
			fflush();
			err(1, "cannot open /map or %s: %m", fn);
		}
	}
	if (fstat(fd, &st)) {
		printf ("error in fstat\n");
		fflush();
		err(1, "fstat: %m");
	}
	if (stat(LASTLOG, &lst)) {
		printf ("error in stat\n");
		fflush();
		err(1, "stat: %m");
	}
	st.st_size -= sizeof (magic);
	if (st.st_size < 0 || (st.st_size % sizeof (*mf)) != 0 ||
	    read(fd, (char *) &magic, sizeof (magic)) != sizeof (magic) ||
	    ntohs(magic) != MAPMAGIC) 
		err(1, "%s is not a proper map file", fn);
	if ((mf = (struct mapfent *) malloc((unsigned) st.st_size)) == NULL) {
		printf("malloc error\n");
		fflush();
		err(1, "cannot allocate %d map bytes: %m", st.st_size);
	}
	if (read(fd, (char *) mf, st.st_size) != st.st_size) {
		printf("read bomb\n");
		fflush();
		err(1, "map read: %m");
	}
	nmf = st.st_size / sizeof (*mf);
	for (m = &mf[nmf]; --m >= mf;) {
		m->mf_uid = ntohl(m->mf_uid);
		m->mf_gid = ntohl(m->mf_gid);
	}
	for (mtmp = nmf, m = &mf[nmf]; --m >= mf;) {
		--mtmp;
		if(m->mf_uid == -1) continue;
		if ((mtmp+1) * sizeof lastlog > lst.st_size) /* lastlog record */
			continue;		 /* not written for user */
		lseek(lfd, (long)(mtmp * sizeof (struct lastlog)), L_SET);
		if(read(lfd, &lastlog, sizeof (struct lastlog)) 
				!= sizeof (struct lastlog))
			err(1, "bad read from lastlog file - old uid %d", mtmp);
		lseek(nfd, (long)(m->mf_uid * sizeof (struct lastlog)), L_SET);
		if(write(nfd, &lastlog, sizeof (struct lastlog)) 
				!= sizeof (struct lastlog))
			err(1, "bad write to newlastlog file");
	}

}

cleanup()
{
	if (unlink(LASTLOG) == -1) err(1, "unlink: %m");
	if (rename(outf, LASTLOG) != 0) err(1, "rename: %m"); 
}
