#ifndef lint
static char rcsid[] = "$Header: mapfile.c,v 1.2 86/10/05 02:48:23 chris Exp $";
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <netinet/in.h>
#include "alloc.h"
#include "mf.h"

static	char *mapfn;
static	int mapfd;
static	struct mapfent *mapbuf;
static	int mapsize;
static	struct mapfent nullmapfent;

char	*malloc(), *realloc();

/*
 * Open a map file.
 */
openmapfile(fn)
	char *fn;
{
	register int n;
	register struct mapfent *mf;

	if (mapfn != NULL)
		closemapfile();
	mapfd = open(mapfn = savestr(fn), O_WRONLY|O_CREAT, 0666);
	if (mapfd < 0)
		err(1, "cannot open %s for writing: %m", mapfn);
	n = 256;
	mf = (struct mapfent *) malloc((unsigned) (n * sizeof (*mapbuf)));
	if (mf == NULL)
		err(1, "openmapfile: out of memory: %m");
	mapbuf = mf;
	mapsize = n;
	nullmapfent.mf_uid = nullmapfent.mf_gid = htonl(-1);
	while (--n >= 0)
		*mf++ = nullmapfent;
}

closemapfile()
{
	register int n;
	short m = htons(MAPMAGIC);

	if (mapfn == NULL)
		err(1, "bug! closemapfile() without openmapfile()");
	n = mapsize * sizeof (*mapbuf);
	if (write(mapfd, (char *) &m, sizeof (m)) != sizeof (m) ||
	    write(mapfd, (char *) mapbuf, n) != n)
		err(1, "write(%s): %m", mapfn);
	if (close(mapfd))
		err(1, "close(%s): %m", mapfn);
	free((char *) mapbuf);
	free(mapfn);
	mapfn = NULL;
}

/*
 * Insert a map entry.
 */
putmapelt(from, to, isgid)
	register int from;
	int to, isgid;
{
	register struct mapfent *mf;

	if (mapfn == NULL)
		err(1, "bug! putmapelt() without openmapfile()");

	/*
	 * Make room if necessary.  The rounding to 256 is purely for
	 * efficiency.
	 */
	if (from >= mapsize) {
		register int n;

		/* compute new size, and allocate */
		n = (from + mapsize + 256) & ~255;
		mapbuf = (struct mapfent *) realloc((char *) mapbuf,
			(unsigned) (n * sizeof (*mapbuf)));
		if (mapbuf == NULL)
			err(1, "\
putmapelt: cannot map from %d: out of memory: %m", from);

		/* initialise new elements */
		mf = &mapbuf[mapsize];
		n -= mapsize;
		mapsize += n;
		while (--n >= 0)
			*mf++ = nullmapfent;
	}

	/*
	 * Now simply insert in place.
	 */
	mf = &mapbuf[from];
	if (isgid)
		mf->mf_gid = htonl(to);
	else
		mf->mf_uid = htonl(to);
}
