#ifndef lint
static char rcsid[] = "$Header: mygrp.c,v 1.2 86/10/05 02:34:31 chris Exp $";
#endif

#include <stdio.h>
#include "mygrp.h"
#include "subr.h"

static	FILE *gr_file;
/*
 * Group reading routines.
 */
void
mysetgrent(file)
	char *file;
{

	if (gr_file != NULL)
		(void) fclose(gr_file);
	gr_file = rfopen(file);
	gr_fname = file;
	gr_lineno = 0;
}

struct mygroup *
mygetgrent()
{
	register char *p;
	register int l;
	static struct mygroup gr;
	static char line[20480];/* Just In Case */
	char *index();

#define	I(x) x			/* purely for style */
#define	FIELD(kind, apply) \
	if (p == NULL) \
		goto bad; \
	gr.kind = apply(p); \
	p = index(p, ':'); \
	if (p != NULL) \
		*p++ = 0

	if (gr_file == NULL)
		err(1, "bug! mygetgrent() without mysetgrent()");
again:
	(void) fgets(p = line, sizeof (line), gr_file);
	if (ferror(gr_file))
		err(1, "read(%s): %m", gr_fname);
	if (feof(gr_file))
		return (NULL);
	gr_lineno++;
	if (*p == 0 || *p == ':' || p[l = strlen(p) - 1] != '\n')
		goto bad;
	p[l] = 0;
	FIELD(gr_name, I);
	FIELD(gr_passwd, I);
	FIELD(gr_gid, atoi);
	FIELD(gr_memlist, I);
	if (p != NULL) {
bad:
		err(0, "invalid line %d of %s ignored", gr_lineno, gr_fname);
		goto again;
	}
	return (&gr);
#undef I
#undef FIELD
}

void
myendgrent()
{

	if (gr_file != NULL) {
		(void) fclose(gr_file);
		gr_file = NULL;
	}
}
