#ifndef lint
static char rcsid[] = "$Header: mypwd.c,v 1.2 86/10/05 02:35:01 chris Exp $";
#endif

#include <stdio.h>
#include <pwd.h>
#include "mypwd.h"
#include "subr.h"

static	FILE *pw_file;		/* stdio file for current passwd file */

/*
 * Set up mygetpwent() so that it reads from the given file.
 */
void
mysetpwent(file)
	char *file;
{

	if (pw_file)
		(void) fclose(pw_file);
	pw_file = rfopen(file);
	pw_fname = file;
	pw_lineno = 0;
}

/*
 * Get the next password file entry.
 */
struct passwd *
mygetpwent()
{
	register char *p;
	register int l;
	static struct passwd pw;
	static char line[1024];
	char *index();

#define	I(x) x			/* purely for style */
#define FIELD(kind, apply) \
	if (p == NULL) \
		goto bad; \
	pw.kind = apply(p); \
	p = index(p, ':'); \
	if (p != NULL) \
		*p++ = 0

	if (pw_file == NULL)
		err(1, "bug! mygetpwent() without mysetpwent()");
again:
	(void) fgets(p = line, sizeof (line), pw_file);
	if (ferror(pw_file))
		err(1, "read(%s): %m", pw_fname);
	if (feof(pw_file))
		return (NULL);
	pw_lineno++;
	/* perform a few simple checks */
	if (*p == 0 || *p == ':' || p[l = strlen(p) - 1] != '\n')
		goto bad;
	p[l] = 0;
	FIELD(pw_name, I);
	FIELD(pw_passwd, I);
	FIELD(pw_uid, atoi);
	FIELD(pw_gid, atoi);
	pw.pw_quota = 0;
	pw.pw_comment = "";
	FIELD(pw_gecos, I);
	FIELD(pw_dir, I);
	FIELD(pw_shell, I);
	if (p != NULL) {
bad:
		err(0, "invalid line %d of %s ignored", pw_lineno, pw_fname);
		goto again;
	}
	return (&pw);
#undef I
#undef FIELD
}

void
myendpwent()
{

	if (pw_file != NULL) {
		(void) fclose(pw_file);
		pw_file = NULL;
	}
}
