#! /bin/sh
#
# unowned.sh - translate zap's `unowned file' errors to file names.

script=/tmp/unowned.$$
trap "rm -f $script; exit 1" 0 1 2 3 15

awk 'BEGIN {
	script = "'$script'";
	nsed = "sed -e \"s,[0-9]* [ \t]*,$fs,\" -e s,//,/,";
}
/\/dev\// {
	if (any)
		printf("%s | %s\n\n", fs, nsed) > script;
	split($1, v, ":"); fs = v[1];
	n = split(fs, t, "/");
	blkdev = t[n];
	if (length(blkdev) > 4 && substr(blkdev, 1, 1) == "r")
		blkdev = substr(blkdev, 2);
	any = 0; next
}
/unowned/ {
	if (!any) {
		printf("fs=`grep %s /etc/fstab | sed -e \"%s\" -e \"%s\"`\n", \
			blkdev, "s/[^ \t:]*[ \t:]//", "s/[ \t:].*//") > script;
		printf("ncheck -i \\\n") > script;
	}
	printf("%d \\\n", $3) > script;
	any = 1; next
}
{ print }
END {
	if (any)
		printf("%s | %s\n", fs, nsed) > script;
}'

if [ -z $script ]; then
	echo "no unowned files"
else
	echo "unowned files:"
	. $script
fi
